/* Experimenteller Webserver 0.2 (c) 2003 by Dennis Schwerdel
 * Dieses Programm ist freie Software, es kann nur im Rahmen der
 * GNU General Public License (GPL) Version 2 oder neuer verwendet werden.
 * -> Siehe license.txt
 */


import server.* ;
import server.httpd.* ;
import config.* ;

import java.io.* ;

public class Main {

  public static void main ( String args[] ) throws Exception {
    if ( args.length > 0 ) {
      PortThread[] st = new PortThread[args.length];
      HttpSettings[] settings = new HttpSettings[args.length];
      for ( int i = 0; i < args.length; i++ ) {
        System.out.println () ;
        System.out.println ( "Using " + args[i] ) ;
        settings[i] = new HttpSettings ( args[i] ) ;
	if ( settings[i].use_ssl ) {
	  st[i] = new HttpsPortThread ( settings[i] ) ;
	} else {
	  st[i] = new HttpPortThread ( settings[i] ) ;
	}
      }
    } else {
      HttpSettings settings = new HttpSettings ( "settings.xml" ) ;
      try {
        if ( settings.use_ssl ) {
          PortThread st = new HttpsPortThread ( settings ) ;
        } else {
          PortThread st = new HttpPortThread ( settings ) ;
        }
      } catch ( java.net.BindException e ) {
        System.err.println ( "Error: Unable to bind port " + settings.port + " !" ) ;
	if ( settings.port < 1024 ) System.err.println ( "On Unix/Linux systems you have to be root to open ports below 1024 !" ) ;
      }
    }

  }

}
