/* Experimenteller Webserver 0.2 (c) 2003 by Dennis Schwerdel
 * Dieses Programm ist freie Software, es kann nur im Rahmen der
 * GNU General Public License (GPL) Version 2 oder neuer verwendet werden.
 * -> Siehe license.txt
 */


package server ;

import java.net.ServerSocket;
import java.net.Socket;
import java.net.BindException ;

public abstract class PortThread extends Thread {
  ServerSocket socket ;

  public PortThread () {
  }

  public PortThread ( int port ) throws Exception {
    socket = new ServerSocket ( port ) ;
    System.out.println ( "Listening on port " + port ) ;
    try {
      this.start () ;
      System.out.println ( "Running..." ) ;
    } catch ( Exception e ) { System.err.println ( e.toString() ) ; }
  }

  protected abstract void onConnect ( Socket socket ) throws Exception ;

  public void run () {
    while ( true ) try {
      onConnect ( socket.accept() ) ;
    } catch ( Exception e ) { System.err.println ( e.toString() ) ; }
  }

}
