/* Experimenteller Webserver 0.2 (c) 2003 by Dennis Schwerdel
 * Dieses Programm ist freie Software, es kann nur im Rahmen der
 * GNU General Public License (GPL) Version 2 oder neuer verwendet werden.
 * -> Siehe license.txt
 */

package server ;

import javax.net.ssl.*;
import java.net.* ;
import java.security.*;
import java.util.* ;
import java.io.* ;

public abstract class SSLPortThread extends PortThread {

  public boolean initialized = false ;

  public SSLPortThread () {
  }

  public SSLPortThread ( int port, String file, String passwd, String[] ciphers ) {
    try {
      SSLContext context = SSLContext.getInstance ( "SSL" ) ;
      KeyManagerFactory kmf = KeyManagerFactory.getInstance ( "SunX509" ) ;
      KeyStore ks = KeyStore.getInstance ( "JKS" ) ;
      InputStream fin = new FileInputStream ( file ) ;
      char[] passphrase = passwd.toCharArray () ;
      System.out.println ( "Key file " + file + " opened" ) ;
      ks.load ( fin, passphrase ) ;
      kmf.init ( ks, passphrase ) ;
      context.init(kmf.getKeyManagers(),null, null);
      Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());
      SSLServerSocketFactory socketFactory = context.getServerSocketFactory();
      if ( ciphers == null ) ciphers = socketFactory.getSupportedCipherSuites() ;
      System.out.println ( "SSL-Ciphers " + Arrays.asList ( ciphers ) ) ;
      SSLServerSocket sslSocket = (SSLServerSocket)socketFactory.createServerSocket(port);
      sslSocket.setEnabledCipherSuites(ciphers);
      sslSocket.setEnableSessionCreation(true);
      socket = sslSocket ;
      System.out.println ( "Listening on port " + port ) ;
      this.start () ;
      System.out.println ( "Running..." ) ;
    } catch ( Exception e ) { System.err.println ( e.toString() ) ; }
  }

}
