/* Experimenteller Webserver 0.2 (c) 2003 by Dennis Schwerdel
 * Dieses Programm ist freie Software, es kann nur im Rahmen der
 * GNU General Public License (GPL) Version 2 oder neuer verwendet werden.
 * -> Siehe license.txt
 */


package server.httpd ;

import config.xml.* ;
import java.io.BufferedInputStream ;
import java.io.InputStream ;

public class Executor {

  public Executor ( XMLDocument xml ) {
  }
  
  public InputStream run ( String virtualFile, String realFile ) throws Exception {
    Runtime r = Runtime.getRuntime () ;
    Process p = r.exec ( realFile ) ;
    BufferedInputStream bis = new BufferedInputStream ( p.getInputStream () ) ;
    p.waitFor () ;
    return bis ;
  }
   
  /*
Aspekte der dynamischen Ausfhrung
action
	="return"	( einfach Datei ausgeben )
	="exec"		( Datei ausfhren )
output
	="stdout"		( Standardausgabe )
	="stderr"		( Standarderror )
	="file(ausgabe.html)"	( Inhalt von ausgabe.html )*
	="text(Ausgefhrt.)"	( Text )*
	="stderrout"		( Err falls vorhanden, sonst out )
input
	="text(blah)"		( Text )*
	="file(input.dat)"	( Inhalt von input.dat )*
command
	="blah %params" 	( Befehl )**
param
	="%name=%value"		***
param-seperate
	=","
	
*: Es knnen folgende Platzhalter verwendet werden:
	%virt		kompletter virtueller Dateiname
	%real		kompletter realer Dateiname
	%file		Dateiname ohne Pfad
	%vpath		virtueller Pfad
	%rpath		realer Pfad
**: Zustzlich zu * kann verwendet werden:
	%params		Zusammengestzter Parameterstring
***: Zustzlich zu * kann verwendet werden:
	%name		Name des Parameters
	%value		Wert des Parameters
	
<executor name="php">
  <output>stderrout</output>
  <input></input>
  <command>php -f %real</command>
</executor>	
	
   */
}
