/* Experimenteller Webserver 0.2 (c) 2003 by Dennis Schwerdel
 * Dieses Programm ist freie Software, es kann nur im Rahmen der
 * GNU General Public License (GPL) Version 2 oder neuer verwendet werden.
 * -> Siehe license.txt
 */

package server.httpd ;

import java.io.FileOutputStream ;
import config.xml.* ;

public class HttpSettings {

  public PathHolder paths ;
  public MimeHolder mimes ;
  public Executor exec ;
  public boolean use_ssl = false ;
  public String ssl_keystore ;
  public String ssl_passwd ;
  public int port = -1 ;
  public int buffersize = -1 ;
  public FileOutputStream logfile ;
  
  private XMLDocument xml ;
  
  public HttpSettings ( String file ) {
    try {
      xml = new XMLDocument ( file ) ;
      paths = new PathHolder ( xml ) ;
      mimes = new MimeHolder ( xml ) ;
      exec = new Executor ( xml ) ;
      port = Integer.parseInt ( xml.getValue ( "settings.port" ) ) ;
      use_ssl = Boolean.valueOf ( xml.getValue ( "settings.ssl#use" ) ).booleanValue() ;
      if ( use_ssl ) {
        ssl_keystore = xml.getValue ( "settings.keystore" ) ;
	ssl_passwd = xml.getValue ( "settings.passwd" ) ;
        if ( port < 0 || port > 65535 ) port = 443 ;
      } else if ( port < 0 || port > 65535 ) port = 80 ;
      buffersize = Integer.parseInt ( xml.getValue ( "settings.buffersize" ) ) ;
      if ( buffersize < 128 ) buffersize = 8192 ;
      logfile = new FileOutputStream ( xml.getValue ( "settings.logfile" ), true ) ;
    } catch ( Exception e ) { System.err.println ( "1:" + e.toString () ) ; }
  }

}
