/* Experimenteller Webserver 0.2 (c) 2003 by Dennis Schwerdel
 * Dieses Programm ist freie Software, es kann nur im Rahmen der
 * GNU General Public License (GPL) Version 2 oder neuer verwendet werden.
 * -> Siehe license.txt
 */

package server.httpd ;

import config.xml.* ;
import config.Translator ;

import org.w3c.dom.NodeList;

public class MimeHolder implements Translator {

  private String[] ext ;
  private String[] mime ;
  private String[] exec ;
  private int count ;

  public MimeHolder ( XMLDocument xml ) throws XMLException {
    count = Integer.parseInt ( xml.getValue ( "settings.[]mime" ) ) ;
    ext = new String [ count ] ;
    mime = new String [ count ] ;
    exec = new String [ count ] ;
    for ( int i = 1; i <= count; i++ ) {
      ext[i-1] = ".*" + xml.getValue ( "settings.mime["+i+"]#ext" ) ;
      mime[i-1] = xml.getValue ( "settings.mime["+i+"]" ) ;
      exec[i-1] = xml.getValue ( "settings.mime["+i+"]#exec" ) ;
    }
  }

  public String resolve ( String filename ) {
    String mimeType = "text/html" ;
    for ( int i = 0; i < count; i++ ) {
      if ( filename.matches ( ext[i] ) ) mimeType = mime[i] ;
    }
    return mimeType ;
  }

  public String exec ( String filename ) {
    String execStr = null ;
    for ( int i = 0; i < count; i++ ) {
      if ( filename.matches ( ext[i] ) ) execStr = exec[i] ;
    }
    return execStr ;
  }
  
}
